/***************************************************************
 ************************* A TPP Project ***********************
 ******************** Visit http://tpp.dhs.org *****************
 ***************************************************************
aobject.h

Author(s): Paul Fleischer (polle@denmark.crosswinds.net)
Created: 22. July 1999

Copyright(c) 1999 The AKOS team.
All Rights Reserved.
****************************************************************/

//AKOS Object Class

//We use the dstring class as data.
#include "dstring.h"
#include "string.h"

class avalue;

class aobject
{
 public:
  aobject(char *newName);
  aobject(char *newName, aobject *newParent);
  aobject(aobject *temp, char *newName);
  ~aobject();
  dstring *getName();
  aobject *getChild(unsigned int no);
  aobject *getChild(char *childName);
  aobject *spawnChild(char *childName);
  aobject *spawnChild(aobject *temp, char *childName);
  bool deleteChild(char *childName);
  dstring *getData();
  avalue *getDataPointer();
  void setData(dstring *newValue);
  void setData(char *newValue);
  void setData(avalue *newValue);
  unsigned int getNoOfChilds(void);
  aobject *getType(void);
  aobject *getSubObject(char *subName);
  aobject *lookupObject(char *objname);
  void getFullName(dstring *retName);
  aobject *getParent(void);

  private:
  void atachChild(aobject *child);
  void detachChild(aobject *child);
  void dublicate(aobject *copy);

  aobject *parent;
  avalue *data;
  dstring *name;
  aobject *type;
  bool spawned; /*Wether the object is created by spawnChild, or simply as
		  a new variable in C++.*/

  aobject **children;
  unsigned int noOfChilds;
};

//avalue class

/*
 This class keeps the value of the aobjects, in that way it is possible to
 have multiple aobjects to have the same value, but without having this value
 more than one time in the memory.
 */

class avalue
{ 
 public:
  avalue(void);
  void newRef(void);
  void deleteRef(void);
  avalue *setData(char *newData);
  dstring *getData(void);

 private:
  unsigned int refCount;
  dstring data;
};





